RSpec.describe Olympic::Tournament do
  let(:klass) { OlympicSpec::Tournament }

  describe ".create_tournament" do
    let(:teams) { 16.times.
      map { |i| OlympicSpec::Team.create(name: "Team #{i}") } }

    it "creates a single elimination tournament" do
      tournament = nil
      expect {
        tournament = klass.
          create_tournament(teams: teams, type: :single)
      }.to_not raise_error

      expect(tournament.type).to eq "single"
      expect(tournament.teams.size).to eq teams
      expect(tournament.matches.size).to be 15
      expect(tournament.root.incoming.size).to be 2
      expect(tournament.root.outgoing.size).to be 0

      sources = [].concat(tournament.root.incoming)
      found = []

      Timeout.timeout(5) do
        until sources.empty?
          source = sources.shift

          case source.source_type
          when "OlympicSpec::Match"
            sources.concat(source.source.incoming)
          when "OlympicSpec::Team"
            found << source.source
          else
            raise ArgumentError, "Invalid source type"
          end
        end
      end

      expect(found.size).to be 16
      expect(found).to eq teams
    end
  end
end
