require "rubygems"
require "bundler/setup"
require "simplecov"
require "coveralls"
require "pry"

require "active_support"
require "active_record"
require "olympic"

SimpleCov.formatter = Coveralls::SimpleCov::Formatter
SimpleCov.start do
  add_filter "spec"
end

Dir[File.dirname(__FILE__) + "/{support,helpers}/**/*.rb"].
  each { |f| require f }
OlympicSpec::Schema.connect

RSpec.configure do |config|

  config.run_all_when_everything_filtered = true
  config.order = "random"

  config.expect_with :rspec do |c|
    c.syntax = :expect
  end

  config.before(:each) do
    OlympicSpec::Schema.load
  end

  config.after(:each) do
    OlympicSpec::Schema.unload
  end

end
